	cpu	z80

;**********************************************
;*      Programm: Untermenue UPKDO            *
;**********************************************
;
UANF:	EQU	0008H       	;..08H-Menue
;
DMA:	EQU	001BH       	;RAM-Speicherplaetze
CONBU:	EQU	0080H
;
GETMS:	EQU	0F35CH     	;Monitor-UPs
WBOOT:	EQU	0F003H
COEXT:	EQU	0F5B9H
ERPAR:	EQU	0F5E6H
;
OUTA:	EQU	000CFH       	;Supervisor-Rufe
PRNST:	EQU	005CFH
GVAL:	EQU	007CFH
CPROM:	EQU	009CFH
MENU:	EQU	00ACFH
OCRLF:	EQU	004CFH

;
CLS:	EQU	0CH          	;Steuerzeichen
ROT:	EQU	0114H
GRUEN:	EQU	0214H
LF:	EQU	0AH
CRLF:	EQU	0A0DH
;
;
	ORG	8000H+UANF
;
	JP	HELP
	DB	"HELP    "
	DB	0
;...
	JP	sadrN
	DB	"nameN   "
	DB	0
	DB	0BBH
	DB	"Kurzerlaeuterungen/Parameter"
	DB	0
;...
	DB	"helptxtN"
	DB	0
;
;zentrale Kommandoschleife
;UPKDO steht als Name im uebergeordneten Menue
;
UPKDO:	EX	AF, AF'
	JR	NC, UPKD1     	;Parameter folgen
                       ;also gleich Ausfuehrung ohne
                       ;Untermenueanzeige
;
	LD	DE,UPTXT     	;Ausgabe Titelzeile
	DW	PRNST
	LD	IX,0BF00H+UANF
	LD	A,1
	DW	MENU         	;Anzeige der Kommandos des
                       ;Untermenues mit den Adressen
;
UPKD2:	LD	HL,CONBU
	LD	(DMA),HL
	LD	A,'*'        	;neues Promptsymbol
	DW	OUTA
	CALL	GETMS       	;Eingabe einer Zeile
	JP	C, WBOOT        	;wenn Fehler vorliegt
	CALL	COEXT
	LD	A,0
	RET	C	;wenn keine Eingabe
                       ;zurueck ins uebergeordnete
                       ;Menue
;
;Einlesen und Ausfuehren Kommando
UPKD1:	DW	GVAL
	JP	Z, ERPAR        	;kein Name
	PUSH	BC
	LD	HL,0BF00H+UANF
	DW	CPROM        	;Name suchen
	POP	BC
	LD	A,0
	RET	NZ	;wenn nicht gefunden
                       ;zurueck ins uebergeordnete
                       ;Menue
	JP	(HL)        	;sonst Ausfuehren des Kdos
;
UPTXT:	DB	CLS
	DW	ROT
	DB	"Untermenue fuer ... "
	DB	"by VP-SOFT 1990"
	DW	GRUEN
	DW	CRLF
	DB	LF
	DB	LF
	DB	0
;
;HELP-Funktion
;
HELP:	DW	OCRLF
	LD	IX,0BF00H+UANF
	LD	A,2          	;Anzeige Help-Texte
	DW	MENU
	JR	UPKD2      	;erneute Kommandoeingabe
                       ;im Untermenue
;
;hier folgen die einzelnen Routinen
;
SADRN:
	XOR	A            	;Cy=0, A=0 --> kein Fehler
	RET		;zurueck ins uebergeordnete
                      ;Menue

	END
